#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg



//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pSendData = NULL;			// Mf[^i[GA
	m_iSendDataSize = 0;		// Mf[^̃TCY
	m_pRecvData = NULL;			// Mf[^i[GA
	m_iRecvDataSize = 0;		// Mf[^̃TCY
}

//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	SAFE_FREE(m_pSendData)		// Mf[^i[GAJ܂
	m_iSendDataSize = 0;
	SAFE_FREE(m_pRecvData)		// Mf[^i[GAJ܂
	m_iRecvDataSize = 0;
}

#define	RCVBUFSIZE		(1024)	// ɓǂލőMTCY
//----------------------------------------------
// function
//    @\Lq֐
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	char	    szRecvBuffer[RCVBUFSIZE + 1];	// Mobt@
	int			iRecvSize;
	pollfd		fds[1] = { 0 };
	char		*pcData = NULL;		// Mf[^
	int			iSendSize = 0;		// Mf[^TCY

	fprintf(stderr, "DoWork()\n");
	fds[0].fd = m_pConInfo->fdClient;
//	fds[0].events = POLLIN | POLLRDHUP;		// MƑ葤̐ؒfCxgݒ
	while (!m_fStopFlag)
	{
		// M̃f[^ȂΑMf[^邩ׂ
		if (iSendSize == 0)
			iSendSize = GetSendData(&pcData);

		fds[0].events = POLLIN | POLLRDHUP;					// MƑ葤̐ؒfCxgݒ
		if (iSendSize > 0)
			fds[0].events |= POLLOUT;						// ݉\ǉ

		poll(fds, 1, 10);
		if (fds[0].revents & POLLRDHUP)			// 葤̐ؒf
		{
			fprintf(stderr, "Disconnected pollrdhup\n");
			fRet = FALSE;
			break;
		}
		else if (fds[0].revents & POLLERR)		// G[
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:DoWork");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		else if (fds[0].revents & POLLIN)		// Mf[^Cxg
		{
			memset(szRecvBuffer, 0, sizeof(szRecvBuffer));
			if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, RCVBUFSIZE, 0)) <= 0)
			{
				m_pConInfo->pCMySyncObject->Lock();
				if (iRecvSize == 0)
					DispErrorMsg("Disconnected recv");
				else
					DispErrorMsg("Err:recv");
				m_pConInfo->pCMySyncObject->UnLock();
				fRet = FALSE;
				break;
			}
			else
			{
				// Mf[^o
				SetRecvData(szRecvBuffer, iRecvSize);
				m_pConInfo->pCMySyncObject->Lock();
				fprintf(stderr, "%s\n", szRecvBuffer);
				m_pConInfo->pCMySyncObject->UnLock();
			}
		}
		else if (fds[0].revents & POLLOUT)		// M\Ȃsend{
		{
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)					// Mf[^ȂɃZbg
			iSendSize = 0;
		}

	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)							// Mf[^ȂɃZbg
	iSendSize = 0;
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	m_pConInfo->pCMySyncObject->Lock();
	// Õf[^ǂ݂ĂȂƂ̓G[ɂ
	if (m_iSendDataSize == 0)
	{
		m_pSendData = (char *)calloc(iSize, sizeof(char));
		memcpy(m_pSendData, pcData, iSize);
		m_iSendDataSize = iSize;
		fRet = TRUE;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	m_pConInfo->pCMySyncObject->Lock();
	if (m_iSendDataSize > 0)
	{
		*ppcData = (char *)calloc(m_iSendDataSize, sizeof(char));
		memcpy(*ppcData, m_pSendData, m_iSendDataSize);
		iSize = m_iSendDataSize;
		SAFE_FREE(m_pSendData)		// ǂݏosƂZbg
			m_iSendDataSize = 0;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(iSize);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetRecvData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	m_pConInfo->pCMySyncObject->Lock();
	// Õf[^ǂ݂ĂȂƂ̓G[ɂ
	if (m_iRecvDataSize == 0)
	{
		m_pRecvData = (char *)calloc(iSize, sizeof(char));
		memcpy(m_pRecvData, pcData, iSize);
		m_iRecvDataSize = iSize;
		fRet = TRUE;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetRecvData(char **ppcData)
{
	int		iSize = 0;

	m_pConInfo->pCMySyncObject->Lock();
	if (m_iRecvDataSize > 0)
	{
		*ppcData = (char *)calloc(m_iRecvDataSize, sizeof(char));
		memcpy(*ppcData, m_pRecvData, m_iRecvDataSize);
		iSize = m_iRecvDataSize;
		SAFE_FREE(m_pRecvData)		// ǂݏosƂZbg
			m_iRecvDataSize = 0;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(iSize);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}
